PostgreSQL Tcl Interface Documentation
Prev | Fast Backward |  | Fast Forward | Next

# pg_connect

## Name

pg_connect -- open a connection to the server

## Synopsis

    pg_connect -conninfo connectOptions ?-connhandle connectionHandleName?
    pg_connect dbName ?-host hostName? ?-port portNumber? ?-tty tty? ?-options serverOptions? ?-connhandle connectionHandleName?
    pg_connect -connlist connectNameValueList ?-connhandle connectionHandleName?

## Description

`pg_connect` opens a connection to the PostgreSQL server.

Three syntaxes are available. In the older one, each possible option has a separate option switch in the `pg_connect` command. In the newer form, a single option string is supplied that can contain multiple option values. The third form takes the parameters as a name value Tcl list. `pg_conndefaults` can be used to retrieve information about the available options in the newer syntax.

## Arguments

New style

connectOptions

  `pg_connect` opens a new database connection using the parameters taken from the `connectOptions` string. Unlike the old-style usage of `pg_connect`, with the new-style usage the parameter set can be extended without requiring changes to either `libpgtcl` or the underlying libpq library, so use of the new style (or its nonexistent nonblocking analogues `pg_connect_start` and `pg_connect_poll`) is preferred for new application programming.

  The passed string can be empty to use all default parameters, or it can contain one or more parameter settings separated by whitespace. Each parameter setting is in the form `keyword = value`. (To write an empty value or a value containing spaces, surround it with single quotes, e.g., `keyword = 'a value'`. Single quotes and backslashes within the value must be escaped with a backslash, i.e., `\'` and `\\`.) Spaces around the equal sign are optional.

  The currently recognized parameter key words are:

  `host`

    Name of host to connect to. If this begins with a slash, it specifies Unix-domain communication rather than TCP/IP communication; the value is the name of the directory in which the socket file is stored. The default is to connect to a Unix-domain socket in `/tmp`.

  `hostaddr`

    Numeric IP address of host to connect to. This should be in the standard IPv4 address format, e.g., `172.28.40.9`. If your machine supports IPv6, you can also use IPv6 address format, e.g., `fe80::203:93ff:fedb:49bc`. TCP/IP communication is always used when a nonempty string is specified for this parameter.

    Using `hostaddr` instead of `host` allows the application to avoid a host name lookup, which may be important in applications with time constraints. However, Kerberos authentication requires the host name. The following therefore applies: If `host` is specified without `hostaddr`, a host name lookup occurs. If `hostaddr` is specified without `host`, the value for `hostaddr` gives the remote address. When Kerberos is used, a reverse name query occurs to obtain the host name for Kerberos. If both `host` and `hostaddr` are specified, the value for `hostaddr` gives the remote address; the value for `host` is ignored, unless Kerberos is used, in which case that value is used for Kerberos authentication. (Note that authentication is likely to fail if libpq is passed a host name that is not the name of the machine at `hostaddr`.) Also, `host` rather than `hostaddr` is used to identify the connection in `$HOME/.pgpass`.

    Without either a host name or host address, Pgtcl will connect using a local Unix domain socket.

  `port`

    Port number to connect to at the server host, or socket file name extension for Unix-domain connections.

  `dbname`

    The database name. Defaults to be the same as the user name.

  `user`

    PostgreSQL user name to connect as.

  `password`

    Password to be used if the server demands password authentication.

  `connect_timeout`

    Maximum wait for connection, in seconds (write as a decimal integer string). Zero or not specified means wait indefinitely. It is not recommended to use a timeout of less than 2 seconds.

  `options`

    Command-line options to be sent to the server.

  `tty`

    Ignored (formerly, this specified where to send server debug output).

  `sslmode`

    This option determines whether or with what priority an SSL connection will be negotiated with the server. There are four modes: `disable` will attempt only an unencrypted SSL connection; `allow` will negotiate, trying first a non-SSL connection, then if that fails, trying an SSL connection; `prefer` (the default) will negotiate, trying first an SSL connection, then if that fails, trying a regular non-SSL connection; `require` will try only an SSL connection.

    If PostgreSQL is compiled without SSL support, using option `require` will cause an error, and options `allow` and `prefer` will be tolerated but libpq will be unable to negotiate an SSL connection.

  `requiressl`

    This option is deprecated in favor of the `sslmode` setting.

    If set to 1, an SSL connection to the server is required (this is equivalent to `sslmode` `require`). libpq will then refuse to connect if the server does not accept an SSL connection. If set to 0 (default), libpq will negotiate the connection type with the server (equivalent to `sslmode` `prefer`). This option is only available if PostgreSQL is compiled with SSL support.

  `service`

    Service name to use for additional parameters. It specifies a service name in `pg_service.conf` that holds additional connection parameters. This allows applications to specify only a service name so connection parameters can be centrally maintained. See `PREFIX/share/pg_service.conf.sample` for information on how to set up the file.

  -connhandle connectionHandleName

    Name to use for the connection handle, instead of pgtcl generating the name automatically. Without the option, the name is auto-generated, prefixed with pgsql, and with a numeric id at the end. This gives the programmer control over the name of the connection handle.

  If any parameter is unspecified, then the corresponding environment variable (see `libpq` documentation in the PostgreSQL manual) is checked. If the environment variable is not set either, then built-in defaults are used.

Old style

dbName

  The name of the database to connect to.

-host hostName

  The host name of the database server to connect to.

-port portNumber

  The TCP port number of the database server to connect to.

-tty tty

  A file or TTY for optional debug output from the server.

-options serverOptions

  Additional configuration options to pass to the server.

-connhandle connectionHandleName

  Name to use for the connection handle, instead of pgtcl generating the name automatically. Without the option, the name is auto-generated, prefixed with pgsql, and with a numeric id at the end. This gives the programmer control over the name of the connection handle.

Third style (most recent one added)

-connlist connectNameValuelist

  `pg_connect` opens a new database connection using the parameters taken from the `connectNameValuelist` list. The parameters are exactly the same for the New Style, but they are stored as a Tcl list, instead of a string. The list is a name value pair, for example: `[list host localhost port 5400 dbname template1]`.

      array set conninfo {
          host    192.168.123.180
          port    5801
          dbname  template1
          user    postgres
      }
      set conn [pg::connect -connlist [array get ::conninfo]]

## Return Value

If successful, a handle for a database connection is returned. Handles start with the prefix `pgsql`.

Prev | Home | Next
pgtcl Command Reference | Up | pg_dbinfo